;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: Timer8_1INT.asm
;;   Version: 2.3, Updated on 2004/07/29 at 17:48:18
;;  Generated by PSoC Designer ver 4.2  b1013 : 02 September, 2004
;;
;;  DESCRIPTION: Timer8 Interrupt Service Routine
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "Timer8_1.inc"


;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------
export  _Timer8_1_ISR


AREA InterruptRAM (RAM,REL,CON)

;@PSoC_UserCode_INIT@ (Do not change this line.)
;---------------------------------------------------
; Insert your custom declarations below this banner
;---------------------------------------------------

;------------------------
; Includes
;------------------------

	
;------------------------
;  Constant Definitions
;------------------------


;------------------------
; Variable Allocation
;------------------------
aa::    BLK	1	;address for "choice"
ai::    BLK	1	;current char address
an::    BLK	9	;0,1,2,...8 - chars
cnt:    BLK	1	;counter for test
buf:    BLK	1	;buffer for test


;---------------------------------------------------
; Insert your custom declarations above this banner
;---------------------------------------------------
;@PSoC_UserCode_END@ (Do not change this line.)


AREA UserModules (ROM, REL)

;-----------------------------------------------------------------------------
;  FUNCTION NAME: _Timer8_1_ISR
;
;  DESCRIPTION: Unless modified, this implements only a null handler stub.
;
;-----------------------------------------------------------------------------
;

_Timer8_1_ISR:

   ;@PSoC_UserCode_BODY@ (Do not change this line.)
    push A
    push X
	;tst reg[PRT1DR],0b00000100
;-------------------- dinamic indication -------------------
	or reg[PRT1DR],0b01001100	;clear all previous positions
	or reg[PRT0DR],0b11011111	;
    mvi A,[ai]					;load current symbol to..  ,[ai]++
    nop							;(no inversion)
    mov reg[PRT2DR],A			;.. to port2
	;"choice" jump operator
	mov A,[aa]					;load offset
	jacc c_1					;and go to cc1...cc9
c_1:and reg[PRT0DR],0b11111110	;fair 1 position
	jmp task1	;task1
c_2:and reg[PRT0DR],0b11111101	;fair 2 position
	jmp c_end	;no task2
c_3:and reg[PRT0DR],0b11111011	;fair 3 position
	jmp c_end	;no task3
c_4:and reg[PRT0DR],0b11110111	;fair 4 position
	jmp c_end	;no task4
c_5:and reg[PRT0DR],0b11101111	;fair 5 position
	jmp c_end	;no task5
c_6:and reg[PRT0DR],0b10111111	;fair 6 position
	jmp c_end	;no task6
c_7:and reg[PRT0DR],0b01111111	;fair 7 position
	jmp c_end	;no task7
c_8:and reg[PRT1DR],0b10111111	;fair 8 position
	jmp c_end	;no task8
c_9:and reg[PRT1DR],0b11110111	;fair 9 position
	jmp c_end	;no task9
c_end:
	add [aa],(c_2-c_1)			;to next address of "choice"
	cmp [ai],an+9				;end position?
	jnz c_end2					;if no
	mov [aa],0					;else load initial address for "choice"
	mov [ai],an					;and load initial address of "char"
	c_end2:

    pop X
    pop A   
    reti


;--------------------- 1 task ---------------------------
task1:	;rotate the string
	add [cnt],8			;speed
	jnc t1_end			;cnt is not overflowed
	mov [buf],[an+8]	;cyclic rotate the string
	mov [an+8],[an+7]
	mov [an+7],[an+6]
	mov [an+6],[an+5]
	mov [an+5],[an+4]
	mov [an+4],[an+3]
	mov [an+3],[an+2]
	mov [an+2],[an+1]
	mov [an+1],[an+0]
	mov [an+0],[buf]
    t1_end:
	jmp c_end
;--------------------- 2 task ---------------------------
task2:
	jmp c_end
;--------------------- 3 task ---------------------------
task3:
	jmp c_end
;--------------------- 4 task ---------------------------
task4:
	jmp c_end
;--------------------- 5 task ---------------------------
task5:
	jmp c_end
;--------------------- 6 task ---------------------------
task6:
	jmp c_end
;--------------------- 7 task ---------------------------
task7:
	jmp c_end
;--------------------- 8 task ---------------------------
task8:
	jmp c_end
;--------------------- 9 task ---------------------------
task9:
	jmp c_end
;-------------------- end of tasks ----------------------
   ;@PSoC_UserCode_END@ (Do not change this line.)

   reti


; end of file Timer8_1INT.asm
